unit UPrnRaw;

{  Based on unit by:
    Mark van der Hijden
    zwoep@menREMOVETHISdrix.nl
    pgp 0x4ED01C6D

   Modified at the Home-Style Kitchens by R.G.M.   6/8/03

}

interface

uses
  WinSpool, SysUtils, Classes, Windows;

    var FHandle : Cardinal;
    procedure StartJob(const PrinterName,JobName: String);
    procedure WriteData(Buf: Pointer; Count: Cardinal);
    procedure StartPage;
    procedure EndPage;
    procedure EndJob;

implementation

{ TPrnRaw }

procedure EndJob;
const
  cLoc = 'EndJob';
begin
  try
    EndPagePrinter(FHandle);
    EndDocPrinter(FHandle);
    ClosePrinter(FHandle);
  finally
    FHandle := 0;
  end;
end;

procedure StartJob(const PrinterName,JobName: String);
const
  cLoc = 'StartJob';
var
  DocInfo1: TDocInfo1;
begin
  if FHandle<>0 then
    raise Exception.Create('StartJob already called @ '+cLoc);
  if not OpenPrinter(PChar(PrinterName),FHandle,nil) then begin
    FHandle := 0;
    raise Exception.Create('OpenPrinter()=False @ '+cLoc+
      ' with PrinterName:'''+PrinterName+'''');
  end;
  with DocInfo1 do begin
   pDocName := PChar(JobName);
   pOutputFile := nil;
   pDataType := 'RAW';
  end;
  StartDocPrinter(FHandle,1,@DocInfo1);
  StartPagePrinter(FHandle);
end;

procedure WriteData(Buf: Pointer; Count: Cardinal);
const
  cLoc = 'WriteData';
var
  Foo : Cardinal;
begin
  if FHandle=0 then
    raise Exception.Create('no print job @ '+cLoc);
  if not WritePrinter(FHandle,Buf,Count,Foo) then
    raise Exception.Create('WritePrinter() API failed @ '+cLoc);
end;

procedure StartPage;
begin
  StartPagePrinter(FHandle);
end;

procedure EndPage;
begin
  EndPagePrinter(FHandle);
end;

end.

